Index: uspace/drv/ohci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/ohci/hw_struct/transfer_descriptor.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/hw_struct/transfer_descriptor.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,6 +41,8 @@
 #include "completion_codes.h"
 
-/* OHCI TDs can handle up to 8KB buffers */
-#define OHCI_TD_MAX_TRANSFER (8 * 1024)
+/* OHCI TDs can handle up to 8KB buffers, however, it can use max 2 pages.
+ * Using 4KB buffers guarantees the page count condition.
+ * (OHCI assumes 4KB pages) */
+#define OHCI_TD_MAX_TRANSFER (4 * 1024)
 
 typedef struct td {
Index: uspace/drv/ohci/ohci_regs.h
===================================================================
--- uspace/drv/ohci/ohci_regs.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/ohci_regs.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,4 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** @addtogroup drvusbohcihc
  * @{
@@ -37,6 +36,6 @@
 #include <stdint.h>
 
-typedef struct ohci_regs
-{
+/** OHCI memory mapped registers structure */
+typedef struct ohci_regs {
 	const volatile uint32_t revision;
 	volatile uint32_t control;
Index: uspace/drv/ohci/root_hub.c
===================================================================
--- uspace/drv/ohci/root_hub.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/root_hub.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,7 +39,9 @@
 
 #include "root_hub.h"
-#include "usb/classes/classes.h"
-#include "usb/devdrv.h"
-#include <usb/request.h>
+#include <usb/classes/classes.h>
+#include <usb/dev/driver.h>
+#include "ohci_regs.h"
+
+#include <usb/dev/request.h>
 #include <usb/classes/hub.h>
 
@@ -109,6 +111,6 @@
  */
 static const uint32_t hub_clear_feature_valid_mask =
-    (1 << USB_HUB_FEATURE_C_HUB_LOCAL_POWER) |
-(1 << USB_HUB_FEATURE_C_HUB_OVER_CURRENT);
+    RHS_OCIC_FLAG |
+    RHS_CLEAR_PORT_POWER;
 
 /**
@@ -116,5 +118,6 @@
  */
 static const uint32_t hub_clear_feature_by_writing_one_mask =
-    1 << USB_HUB_FEATURE_C_HUB_LOCAL_POWER;
+   RHS_CLEAR_PORT_POWER;
+   // 1 << USB_HUB_FEATURE_C_HUB_LOCAL_POWER;
 
 /**
@@ -122,6 +125,8 @@
  */
 static const uint32_t hub_set_feature_valid_mask =
-    (1 << USB_HUB_FEATURE_C_HUB_OVER_CURRENT) |
-(1 << USB_HUB_FEATURE_C_HUB_LOCAL_POWER);
+    RHS_LPSC_FLAG |
+    RHS_OCIC_FLAG;
+    //(1 << USB_HUB_FEATURE_C_HUB_OVER_CURRENT) |
+    //(1 << USB_HUB_FEATURE_C_HUB_LOCAL_POWER);
 
 /**
@@ -129,5 +134,6 @@
  */
 static const uint32_t hub_set_feature_direct_mask =
-    (1 << USB_HUB_FEATURE_C_HUB_OVER_CURRENT);
+    RHS_SET_PORT_POWER;
+    //(1 << USB_HUB_FEATURE_C_HUB_OVER_CURRENT);
 
 /**
@@ -135,8 +141,8 @@
  */
 static const uint32_t port_set_feature_valid_mask =
-    (1 << USB_HUB_FEATURE_PORT_ENABLE) |
-(1 << USB_HUB_FEATURE_PORT_SUSPEND) |
-(1 << USB_HUB_FEATURE_PORT_RESET) |
-(1 << USB_HUB_FEATURE_PORT_POWER);
+    RHPS_SET_PORT_ENABLE |
+    RHPS_SET_PORT_SUSPEND |
+    RHPS_SET_PORT_RESET |
+    RHPS_SET_PORT_POWER;
 
 /**
@@ -144,26 +150,39 @@
  */
 static const uint32_t port_clear_feature_valid_mask =
+    RHPS_CCS_FLAG |
+    RHPS_SET_PORT_SUSPEND |
+    RHPS_POCI_FLAG |
+    RHPS_SET_PORT_POWER |
+    RHPS_CSC_FLAG |
+    RHPS_PESC_FLAG |
+    RHPS_PSSC_FLAG |
+    RHPS_OCIC_FLAG |
+    RHPS_PRSC_FLAG;
+
+/*
+
     (1 << USB_HUB_FEATURE_PORT_CONNECTION) |
-(1 << USB_HUB_FEATURE_PORT_SUSPEND) |
-(1 << USB_HUB_FEATURE_PORT_OVER_CURRENT) |
-(1 << USB_HUB_FEATURE_PORT_POWER) |
-(1 << USB_HUB_FEATURE_C_PORT_CONNECTION) |
-(1 << USB_HUB_FEATURE_C_PORT_ENABLE) |
-(1 << USB_HUB_FEATURE_C_PORT_SUSPEND) |
-(1 << USB_HUB_FEATURE_C_PORT_OVER_CURRENT) |
-(1 << USB_HUB_FEATURE_C_PORT_RESET);
+    (1 << USB_HUB_FEATURE_PORT_SUSPEND) |
+    (1 << USB_HUB_FEATURE_PORT_OVER_CURRENT) |
+    (1 << USB_HUB_FEATURE_PORT_POWER) |
+    (1 << USB_HUB_FEATURE_C_PORT_CONNECTION) |
+    (1 << USB_HUB_FEATURE_C_PORT_ENABLE) |
+    (1 << USB_HUB_FEATURE_C_PORT_SUSPEND) |
+    (1 << USB_HUB_FEATURE_C_PORT_OVER_CURRENT) |
+    (1 << USB_HUB_FEATURE_C_PORT_RESET);
+ */
 //note that USB_HUB_FEATURE_PORT_POWER bit is translated into
-//USB_HUB_FEATURE_PORT_LOW_SPEED
+//USB_HUB_FEATURE_PORT_LOW_SPEED for port set feature request
 
 /**
  * bitmask with port status changes
  */
-static const uint32_t port_status_change_mask =
-    (1 << USB_HUB_FEATURE_C_PORT_CONNECTION) |
-(1 << USB_HUB_FEATURE_C_PORT_ENABLE) |
-(1 << USB_HUB_FEATURE_C_PORT_OVER_CURRENT) |
-(1 << USB_HUB_FEATURE_C_PORT_RESET) |
-(1 << USB_HUB_FEATURE_C_PORT_SUSPEND);
-
+static const uint32_t port_status_change_mask = RHPS_CHANGE_WC_MASK;
+/*    (1 << USB_HUB_FEATURE_C_PORT_CONNECTION) |
+    (1 << USB_HUB_FEATURE_C_PORT_ENABLE) |
+    (1 << USB_HUB_FEATURE_C_PORT_OVER_CURRENT) |
+    (1 << USB_HUB_FEATURE_C_PORT_RESET) |
+    (1 << USB_HUB_FEATURE_C_PORT_SUSPEND);
+*/
 
 static int create_serialized_hub_descriptor(rh_t *instance);
Index: uspace/drv/ohci/root_hub.h
===================================================================
--- uspace/drv/ohci/root_hub.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/root_hub.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,4 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** @addtogroup drvusbohci
  * @{
@@ -37,5 +36,5 @@
 
 #include <usb/usb.h>
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #include "ohci_regs.h"
Index: uspace/drv/ohci/utils/malloc32.h
===================================================================
--- uspace/drv/ohci/utils/malloc32.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/utils/malloc32.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,12 +26,12 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup usb
+/** @addtogroup drvusbohci
  * @{
  */
 /** @file
- * @brief UHCI driver
+ * @brief OHCI driver
  */
-#ifndef DRV_UHCI_TRANSLATOR_H
-#define DRV_UHCI_TRANSLATOR_H
+#ifndef DRV_OHCI_UTILS_MALLOC32_H
+#define DRV_OHCI_UTILS_MALLOC32_H
 
 #include <assert.h>
@@ -40,6 +40,4 @@
 #include <mem.h>
 #include <as.h>
-
-#define UHCI_REQUIRED_PAGE_SIZE 4096
 
 /** Get physical address translation
@@ -61,5 +59,5 @@
  *
  * @param[in] size Size of the required memory space
- * @return Address of the alligned and big enough memory place, NULL on failure.
+ * @return Address of the aligned and big enough memory place, NULL on failure.
  */
 static inline void * malloc32(size_t size)
@@ -72,23 +70,4 @@
 static inline void free32(void *addr)
 	{ if (addr) free(addr); }
-/*----------------------------------------------------------------------------*/
-/** Create 4KB page mapping
- *
- * @return Address of the mapped page, NULL on failure.
- */
-static inline void * get_page(void)
-{
-	void * free_address = as_get_mappable_page(UHCI_REQUIRED_PAGE_SIZE);
-	assert(free_address);
-	if (free_address == 0)
-		return NULL;
-	void* ret =
-	  as_area_create(free_address, UHCI_REQUIRED_PAGE_SIZE,
-		  AS_AREA_READ | AS_AREA_WRITE);
-	if (ret != free_address)
-		return NULL;
-	return ret;
-}
-
 #endif
 /**
Index: uspace/drv/uhci-hcd/batch.c
===================================================================
--- uspace/drv/uhci-hcd/batch.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/batch.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -45,24 +45,35 @@
 #define DEFAULT_ERROR_COUNT 3
 
+/** UHCI specific data required for USB transfer */
 typedef struct uhci_transfer_batch {
+	/** Queue head
+	 * This QH is used to maintain UHCI schedule structure and the element
+	 * pointer points to the first TD of this batch.
+	 */
 	qh_t *qh;
+	/** List of TDs needed for the transfer */
 	td_t *tds;
+	/** Number of TDs used by the transfer */
+	size_t td_count;
+	/** Data buffer, must be accessible by the UHCI hw */
 	void *device_buffer;
-	size_t td_count;
 } uhci_transfer_batch_t;
 /*----------------------------------------------------------------------------*/
-static void uhci_transfer_batch_dispose(void *uhci_batch)
-{
-	uhci_transfer_batch_t *instance = uhci_batch;
-	assert(instance);
-	free32(instance->device_buffer);
-	free(instance);
-}
-/*----------------------------------------------------------------------------*/
-
 static void batch_control(usb_transfer_batch_t *instance,
     usb_packet_id data_stage, usb_packet_id status_stage);
 static void batch_data(usb_transfer_batch_t *instance, usb_packet_id pid);
-
+/*----------------------------------------------------------------------------*/
+/** Safely destructs uhci_transfer_batch_t structure
+ *
+ * @param[in] uhci_batch Instance to destroy.
+ */
+static void uhci_transfer_batch_dispose(void *uhci_batch)
+{
+	uhci_transfer_batch_t *instance = uhci_batch;
+	assert(instance);
+	free32(instance->device_buffer);
+	free(instance);
+}
+/*----------------------------------------------------------------------------*/
 /** Allocate memory and initialize internal data structure.
  *
@@ -70,5 +81,5 @@
  * @param[in] ep Communication target
  * @param[in] buffer Data source/destination.
- * @param[in] size Size of the buffer.
+ * @param[in] buffer_size Size of the buffer.
  * @param[in] setup_buffer Setup data source (if not NULL)
  * @param[in] setup_size Size of setup_buffer (should be always 8)
@@ -84,5 +95,6 @@
  */
 usb_transfer_batch_t * batch_get(ddf_fun_t *fun, endpoint_t *ep,
-    char *buffer, size_t buffer_size, char* setup_buffer, size_t setup_size,
+    char *buffer, size_t buffer_size,
+    const char* setup_buffer, size_t setup_size,
     usbhc_iface_transfer_in_callback_t func_in,
     usbhc_iface_transfer_out_callback_t func_out, void *arg)
@@ -173,6 +185,6 @@
 		instance->error = td_status(&data->tds[i]);
 		if (instance->error != EOK) {
-			usb_log_debug("Batch(%p) found error TD(%zu):%" PRIx32 ".\n",
-			    instance, i, data->tds[i].status);
+			usb_log_debug("Batch(%p) found error TD(%zu):%"
+			    PRIx32 ".\n", instance, i, data->tds[i].status);
 			td_print_status(&data->tds[i]);
 
@@ -397,4 +409,5 @@
 /*----------------------------------------------------------------------------*/
 /** Provides access to QH data structure.
+ *
  * @param[in] instance Batch pointer to use.
  * @return Pointer to the QH used by the batch.
Index: uspace/drv/uhci-hcd/batch.h
===================================================================
--- uspace/drv/uhci-hcd/batch.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/batch.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -45,5 +45,5 @@
 usb_transfer_batch_t * batch_get(
     ddf_fun_t *fun, endpoint_t *ep, char *buffer, size_t size,
-    char *setup_buffer, size_t setup_size,
+    const char *setup_buffer, size_t setup_size,
     usbhc_iface_transfer_in_callback_t func_in,
     usbhc_iface_transfer_out_callback_t func_out,
@@ -55,13 +55,10 @@
 
 void batch_control_write(usb_transfer_batch_t *instance);
-
 void batch_control_read(usb_transfer_batch_t *instance);
 
 void batch_interrupt_in(usb_transfer_batch_t *instance);
-
 void batch_interrupt_out(usb_transfer_batch_t *instance);
 
 void batch_bulk_in(usb_transfer_batch_t *instance);
-
 void batch_bulk_out(usb_transfer_batch_t *instance);
 
Index: uspace/drv/uhci-hcd/hc.c
===================================================================
--- uspace/drv/uhci-hcd/hc.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/hc.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -57,9 +57,10 @@
 static int hc_debug_checker(void *arg);
 /*----------------------------------------------------------------------------*/
-/** Initialize UHCI hcd driver structure
+/** Initialize UHCI hc driver structure
  *
  * @param[in] instance Memory place to initialize.
  * @param[in] regs Address of I/O control registers.
- * @param[in] size Size of I/O control registers.
+ * @param[in] reg_size Size of I/O control registers.
+ * @param[in] interrupts True if hw interrupts should be used.
  * @return Error code.
  * @note Should be called only once on any structure.
Index: uspace/drv/uhci-hcd/hc.h
===================================================================
--- uspace/drv/uhci-hcd/hc.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/hc.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -33,6 +33,6 @@
  * @brief UHCI host controller driver structure
  */
-#ifndef DRV_UHCI_UHCI_HC_H
-#define DRV_UHCI_UHCI_HC_H
+#ifndef DRV_UHCI_HC_H
+#define DRV_UHCI_HC_H
 
 #include <fibril.h>
@@ -95,5 +95,5 @@
 #define UHCI_NEEDED_IRQ_COMMANDS 5
 
-/* Main HC driver structure */
+/** Main UHCI driver structure */
 typedef struct hc {
 	/** USB bus driver, devices and addresses */
Index: uspace/drv/uhci-hcd/hw_struct/link_pointer.h
===================================================================
--- uspace/drv/uhci-hcd/hw_struct/link_pointer.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/hw_struct/link_pointer.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -32,6 +32,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_LINK_POINTER_H
-#define DRV_UHCI_LINK_POINTER_H
+#ifndef DRV_UHCI_HW_STRUCT_LINK_POINTER_H
+#define DRV_UHCI_HW_STRUCT_LINK_POINTER_H
 
 /* UHCI link pointer, used by many data structures */
Index: uspace/drv/uhci-hcd/hw_struct/queue_head.h
===================================================================
--- uspace/drv/uhci-hcd/hw_struct/queue_head.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/hw_struct/queue_head.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup drv usbuhcihc
+/** @addtogroup drvusbuhcihc
  * @{
  */
@@ -32,6 +32,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_QH_H
-#define DRV_UHCI_QH_H
+#ifndef DRV_UHCI_HW_STRUCT_QH_H
+#define DRV_UHCI_HW_STRUCT_QH_H
 #include <assert.h>
 
@@ -65,5 +65,5 @@
  *
  * @param[in] instance qh_t structure to use.
- * @param[in] pa Physical address of the next queue head.
+ * @param[in] next Address of the next queue.
  *
  * Adds proper flag. If the pointer is NULL, sets next to terminal NULL.
@@ -81,6 +81,6 @@
 /** Set queue head element pointer
  *
- * @param[in] instance qh_t structure to initialize.
- * @param[in] pa Physical address of the TD structure.
+ * @param[in] instance qh_t structure to use.
+ * @param[in] td Transfer descriptor to set as the first element.
  *
  * Adds proper flag. If the pointer is NULL, sets element to terminal NULL.
Index: uspace/drv/uhci-hcd/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/uhci-hcd/hw_struct/transfer_descriptor.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/hw_struct/transfer_descriptor.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -32,6 +32,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_TRANSFER_DESCRIPTOR_H
-#define DRV_UHCI_TRANSFER_DESCRIPTOR_H
+#ifndef DRV_UHCI_HW_STRUCT_TRANSFER_DESCRIPTOR_H
+#define DRV_UHCI_HW_STRUCT_TRANSFER_DESCRIPTOR_H
 
 #include <mem.h>
Index: uspace/drv/uhci-hcd/root_hub.h
===================================================================
--- uspace/drv/uhci-hcd/root_hub.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/root_hub.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -33,6 +33,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_UHCI_RH_H
-#define DRV_UHCI_UHCI_RH_H
+#ifndef DRV_UHCI_RH_H
+#define DRV_UHCI_RH_H
 
 #include <ddf/driver.h>
Index: uspace/drv/uhci-hcd/transfer_list.c
===================================================================
--- uspace/drv/uhci-hcd/transfer_list.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/transfer_list.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,4 +34,5 @@
 #include <errno.h>
 #include <usb/debug.h>
+#include <arch/barrier.h>
 
 #include "transfer_list.h"
@@ -71,5 +72,5 @@
  * @param[in] instance Memory place to use.
  *
- * Frees memory for internal qh_t structure.
+ * Frees memory of the internal qh_t structure.
  */
 void transfer_list_fini(transfer_list_t *instance)
@@ -126,9 +127,13 @@
 	assert((pa & LINK_POINTER_ADDRESS_MASK) == pa);
 
+	/* Make sure all data in the batch are written */
+	write_barrier();
+
 	/* keep link */
 	batch_qh(batch)->next = last_qh->next;
 	qh_set_next_qh(last_qh, batch_qh(batch));
 
-	asm volatile ("": : :"memory");
+	/* Make sure the pointer is updated */
+	write_barrier();
 
 	/* Add to the driver list */
@@ -222,5 +227,8 @@
 	    == addr_to_phys(batch_qh(batch)));
 	prev_qh->next = batch_qh(batch)->next;
-	asm volatile ("": : :"memory");
+
+	/* Make sure the pointer is updated */
+	write_barrier();
+
 	/* Remove from the batch list */
 	list_remove(&batch->link);
Index: uspace/drv/uhci-hcd/transfer_list.h
===================================================================
--- uspace/drv/uhci-hcd/transfer_list.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/transfer_list.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -43,6 +43,5 @@
  * of currently executed transfers
  */
-typedef struct transfer_list
-{
+typedef struct transfer_list {
 	/** Guard against multiple add/remove races */
 	fibril_mutex_t guard;
Index: uspace/drv/uhci-hcd/uhci.c
===================================================================
--- uspace/drv/uhci-hcd/uhci.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/uhci.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -161,5 +161,4 @@
 /** Initialize hc and rh DDF structures and their respective drivers.
  *
- * @param[in] instance UHCI structure to use.
  * @param[in] device DDF instance of the device to use.
  *
@@ -167,5 +166,5 @@
  *  - gets device's hw resources
  *  - disables UHCI legacy support (PCI config space)
- *  - asks for interrupt
+ *  - attempts to enable interrupts
  *  - registers interrupt handler
  */
Index: uspace/drv/uhci-hcd/utils/malloc32.h
===================================================================
--- uspace/drv/uhci-hcd/utils/malloc32.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/utils/malloc32.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup usb
+/** @addtogroup drvusbuhci
  * @{
  */
@@ -32,6 +32,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_TRANSLATOR_H
-#define DRV_UHCI_TRANSLATOR_H
+#ifndef DRV_UHCI_UTILS_MALLOC32_H
+#define DRV_UHCI_UTILS_MALLOC32_H
 
 #include <assert.h>
@@ -74,5 +74,6 @@
 	if (size <= SLAB_ELEMENT_SIZE)
 		return slab_malloc_g();
-	assert(false);
+	usb_log_warning("Requested %zu bytes, current allocator can't handle "
+	    "that amount, pray that the standard malloc will suffice.", size);
 	return memalign(UHCI_STRCUTURES_ALIGNMENT, size);
 }
Index: uspace/drv/uhci-hcd/utils/slab.c
===================================================================
--- uspace/drv/uhci-hcd/utils/slab.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/utils/slab.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup usb
+/** @addtogroup drvusbuhcihc
  * @{
  */
Index: uspace/drv/uhci-hcd/utils/slab.h
===================================================================
--- uspace/drv/uhci-hcd/utils/slab.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-hcd/utils/slab.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup usb
+/** @addtogroup drvusbuhcihc
  * @{
  */
@@ -32,6 +32,6 @@
  * @brief UHCI driver
  */
-#ifndef DRV_UHCI_SLAB_H
-#define DRV_UHCI_SLAB_H
+#ifndef DRV_UHCI_UTILS_SLAB_H
+#define DRV_UHCI_UTILS_SLAB_H
 
 #include <bool.h>
Index: uspace/drv/uhci-rhd/port.c
===================================================================
--- uspace/drv/uhci-rhd/port.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-rhd/port.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,7 +36,9 @@
 #include <errno.h>
 #include <str_error.h>
+#include <time.h>
+#include <async.h>
 
 #include <usb/usb.h>    /* usb_address_t */
-#include <usb/hub.h>    /* usb_hc_new_device_wrapper */
+#include <usb/dev/hub.h>    /* usb_hc_new_device_wrapper */
 #include <usb/debug.h>
 
@@ -65,5 +67,5 @@
  *
  * @param[in] port Structure to use.
- * @param[in] value New register value.
+ * @param[in] val New register value.
  * @return Error code. (Always EOK)
  */
@@ -77,5 +79,5 @@
  *
  * @param[in] port Memory structure to use.
- * @param[in] addr Address of I/O register.
+ * @param[in] address Address of I/O register.
  * @param[in] number Port number.
  * @param[in] usec Polling interval.
@@ -224,16 +226,10 @@
 		uhci_port_write_status(port, port_status);
 		while (uhci_port_read_status(port) & STATUS_IN_RESET);
-		// TODO: find a better way to waste time (it should be less than
-		// 10ms, if we reschedule it takes too much time (random
-		// interrupts can be solved by multiple attempts).
-		usb_log_debug2("%s: Reset Signal stop.\n", port->id_string);
-	}
+	}
+	/* PIO delay, should not be longer than 3ms as the device might
+	 * enter suspend state. */
+	udelay(10);
 	/* Enable the port. */
 	uhci_port_set_enabled(port, true);
-
-	/* Reset recovery period,
-	 * devices do not have to respond during this period
-	 */
-	async_usleep(10000);
 	return EOK;
 }
Index: uspace/drv/uhci-rhd/port.h
===================================================================
--- uspace/drv/uhci-rhd/port.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/uhci-rhd/port.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -38,5 +38,5 @@
 #include <fibril.h>
 #include <ddf/driver.h>
-#include <usb/usbdevice.h> /* usb_hc_connection_t */
+#include <usb/dev/hc.h> /* usb_hc_connection_t */
 
 typedef uint16_t port_status_t;
Index: uspace/drv/usbflbk/main.c
===================================================================
--- uspace/drv/usbflbk/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbflbk/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,5 +34,5 @@
  * Main routines of USB fallback driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <errno.h>
Index: uspace/drv/usbhid/generic/hiddev.h
===================================================================
--- uspace/drv/usbhid/generic/hiddev.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/generic/hiddev.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,5 +37,5 @@
 #define USB_HID_HIDDDEV_H_
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 struct usb_hid_dev;
Index: uspace/drv/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/usbhid/kbd/kbddev.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/kbd/kbddev.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -46,17 +46,17 @@
 
 #include <usb/usb.h>
-#include <usb/dp.h>
-#include <usb/request.h>
-#include <usb/classes/hid.h>
-#include <usb/pipes.h>
+#include <usb/dev/dp.h>
+#include <usb/dev/request.h>
+#include <usb/hid/hid.h>
+#include <usb/dev/pipes.h>
 #include <usb/debug.h>
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hidparser.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hidut.h>
-#include <usb/classes/hidreq.h>
-#include <usb/classes/hidreport.h>
-#include <usb/classes/hid/utled.h>
-
-#include <usb/devdrv.h>
+#include <usb/hid/usages/core.h>
+#include <usb/hid/request.h>
+#include <usb/hid/hidreport.h>
+#include <usb/hid/usages/led.h>
+
+#include <usb/dev/driver.h>
 
 #include "kbddev.h"
Index: uspace/drv/usbhid/kbd/kbddev.h
===================================================================
--- uspace/drv/usbhid/kbd/kbddev.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/kbd/kbddev.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,9 +41,9 @@
 #include <fibril_synch.h>
 
-#include <usb/classes/hid.h>
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/hidparser.h>
 #include <ddf/driver.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 #include "kbdrepeat.h"
Index: uspace/drv/usbhid/kbd/main.c
===================================================================
--- uspace/drv/usbhid/kbd/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/kbd/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,5 +41,5 @@
 #include <str_error.h>
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #include "kbddev.h"
Index: uspace/drv/usbhid/main.c
===================================================================
--- uspace/drv/usbhid/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,6 +41,6 @@
 #include <str_error.h>
 
-#include <usb/devdrv.h>
-#include <usb/devpoll.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/poll.h>
 
 #include "usbhid.h"
@@ -202,5 +202,5 @@
 	printf(NAME ": HelenOS USB HID driver.\n");
 
-	usb_log_enable(USB_LOG_LEVEL_DEBUG, NAME);
+	usb_log_enable(USB_LOG_LEVEL_DEFAULT, NAME);
 
 	return usb_driver_main(&usb_hid_driver);
Index: uspace/drv/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/usbhid/mouse/mousedev.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/mouse/mousedev.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,7 +37,7 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
-#include <usb/classes/hidreq.h>
-#include <usb/classes/hidut.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/request.h>
+#include <usb/hid/usages/core.h>
 #include <errno.h>
 #include <str_error.h>
Index: uspace/drv/usbhid/mouse/mousedev.h
===================================================================
--- uspace/drv/usbhid/mouse/mousedev.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/mouse/mousedev.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,5 +37,5 @@
 #define USB_HID_MOUSEDEV_H_
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 struct usb_hid_dev;
Index: uspace/drv/usbhid/multimedia/multimedia.c
===================================================================
--- uspace/drv/usbhid/multimedia/multimedia.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/multimedia/multimedia.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,7 +40,7 @@
 #include "keymap.h"
 
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hidparser.h>
 #include <usb/debug.h>
-#include <usb/classes/hidut.h>
+#include <usb/hid/usages/core.h>
 
 #include <errno.h>
Index: uspace/drv/usbhid/multimedia/multimedia.h
===================================================================
--- uspace/drv/usbhid/multimedia/multimedia.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/multimedia/multimedia.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,5 +37,5 @@
 #define USB_HID_MULTIMEDIA_H_
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 struct usb_hid_dev;
Index: uspace/drv/usbhid/subdrivers.c
===================================================================
--- uspace/drv/usbhid/subdrivers.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/subdrivers.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -35,6 +35,6 @@
 
 #include "subdrivers.h"
-#include "usb/classes/hidut.h"
-#include "usb/classes/hidpath.h"
+#include <usb/hid/usages/core.h>
+#include <usb/hid/hidpath.h>
 
 #include "multimedia/multimedia.h"
Index: uspace/drv/usbhid/usbhid.c
===================================================================
--- uspace/drv/usbhid/usbhid.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/usbhid.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,8 +37,8 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
-#include <usb/classes/hidparser.h>
-#include <usb/classes/hidreport.h>
-#include <usb/classes/hidreq.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/hidparser.h>
+#include <usb/hid/hidreport.h>
+#include <usb/hid/request.h>
 #include <errno.h>
 #include <str_error.h>
Index: uspace/drv/usbhid/usbhid.h
===================================================================
--- uspace/drv/usbhid/usbhid.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhid/usbhid.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,9 +39,9 @@
 #include <stdint.h>
 
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hidparser.h>
 #include <ddf/driver.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
-#include <usb/classes/hid.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
+#include <usb/hid/hid.h>
 #include <bool.h>
 
Index: uspace/drv/usbhub/main.c
===================================================================
--- uspace/drv/usbhub/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,5 +36,5 @@
 #include <stdio.h>
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/classes/classes.h>
 
Index: uspace/drv/usbhub/port_status.h
===================================================================
--- uspace/drv/usbhub/port_status.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/port_status.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -35,5 +35,5 @@
 #include <bool.h>
 #include <sys/types.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include "usbhub_private.h"
 
Index: uspace/drv/usbhub/ports.h
===================================================================
--- uspace/drv/usbhub/ports.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/ports.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,6 +36,6 @@
 #define DRV_USBHUB_PORTS_H
 
-#include <usb/devdrv.h>
-#include <usb/hub.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/hub.h>
 
 typedef struct usb_hub_info_t usb_hub_info_t;
